package com.eactive.eai.batch.job.jobItem.fiusc;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_FIUSC_0314 extends DefaultTelegram implements TelegramService
{
    private int SEND_LENGTH;            //길이 필드를 제외한 전문의 총길이
    private int REAL_SEND_LENGTH;       //실제 송신할 전문의 총길이( SEND_LENGTH + 길이필드 길이)

    private Properties       telegramInfo;
    private File             file;
    private FileOutputStream fout;
    private String           RTN_CD;
    private int block_data_size = 0;

    /**
     * 생성자
     */
    public SEND_FIUSC_0314() {
        //결번확인통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = compareSeqNSize();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            int i = -1;
            //전문송신  전체 Byte 수
            compileField(++i, ""+REAL_SEND_LENGTH, this.al_FieldProps[i]);
            
            // Transaction Code
            compileField(++i, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[i]);

            // 시스템명칭 (FIU)
            compileField(++i, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[i]);
            
            // 참가기관코드
            compileField(++i, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[i]);
            
            //사용자ID
            byte[] userId = new byte[20];
            for ( int inx = 0; inx < userId.length; inx++ ){
            	userId[inx] = ' ';
            }
            
            System.arraycopy(batchDoc.getBatchMsg().getHeader().getUserID().getBytes(), 0, userId, 0,
            		Math.min(batchDoc.getBatchMsg().getHeader().getUserID().getBytes().length, 20));

            al_Field.set(++i, userId);
            
            //전문종별코드.
            compileField(++i, this.getFldTelegramType()+ this.getFldOpCode() + "0", this.al_FieldProps[i]);
            
            //송수신 FLAG : 전문 발생 기관을 구분하여  아래의 값을 SET한다.
            compileField(++i, getFldTrClass(), this.al_FieldProps[i]);

            //기관구분
            compileField(++i, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[i]);

            //계속여부 
            compileField(++i, "Y", this.al_FieldProps[i]);
            
            //응답코드
            compileField(++i, getSendResponseCode(), this.al_FieldProps[i]);
            // 여기 까지 공통부

            //결과
            compileField(++i, RTN_CD, this.al_FieldProps[i]);

            //시퀀스
            compileField(++i, ""+batchDoc.getBatchMsg().getBody().getSeqNum(), this.al_FieldProps[i]);

            //수신크기
            compileField(++i, ""+batchDoc.getBatchMsg().getBody().getCurFileSize(), this.al_FieldProps[i]);
            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
    }

	public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
                
            if ( fout != null ){
                fout.close();
            }
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            //확인결과 정상(RTN_CD='00')이 아닌 경우 재처리를 위해 기수신파일크기 리셋
            if (RTN_CD != "00") {
                long cur_size = this.batchDoc.getBatchMsg().getBody().getCurFileSize();
            	batchDoc.getBatchMsg().getBody().setCurFileSize(cur_size-block_data_size);
            }
            
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }


    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;

            //BATCH작업구분코드 (processCode)에 따른 프로퍼티 정보 가져오기
            telegramInfo = getTelegramInfo();

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error(e.getMessage(),e);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
        	
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;
            
            if (RTN_CD.equals("00")) {
            	if (batchDoc.getBatchMsg().getBody().getCurFileSize() >= batchDoc.getBatchMsg().getHeader().getFileSize()) {
            		this.setConditionTxt(TelegramKeys.EOF);
            	}
            }
            
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }

        return true;
    }

    private boolean compareSeqNSize() {
        try {

            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            int  seq_no   = this.batchDoc.getBatchMsg().getBody().getSeqNum();
            long cur_size = this.batchDoc.getBatchMsg().getBody().getCurFileSize();
            
            // 이전 전문에서 저장한 전문 내용을 꺼내어 본다. 17 자리라고 가정
            String recvTelegramBody = new String(batchDoc.getBatchMsg().getTelegramBody());
            int  recv_seq_no   = Integer.parseInt(recvTelegramBody.substring(0, 7).trim());
            long recv_cur_size = Integer.parseInt(recvTelegramBody.substring(7,17));  // 기송신크기 

            // RTN_CD 비정상에 대한 재처리 테스트 (RECV_FIUSC_0303 처리 시 setRecLen(+1))
         /* if (batchDoc.getBatchMsg().getHeader().getRecLen() == 14) {  
            	recv_cur_size = recv_cur_size - 1;
            	recv_seq_no = recv_seq_no - 1;
            }*/
            
           	if ( cur_size == recv_cur_size){
            	if ( seq_no == recv_seq_no ){
            		RTN_CD = "00";
            	} else {
            		RTN_CD = "01";
            	}
            } else {
            	if ( seq_no == recv_seq_no ){
            		RTN_CD = "10";
            	} else {
            		RTN_CD = "11";
            	}
            }
            
            HashMap<String, Object> hm = JobProcessData.getInstance().getBatchStageData(uuid);
            @SuppressWarnings("unchecked")
			HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);

            if (block_data == null ){
                logger.debug(logHeader + " : " + ExceptionUtil.getErrorCode("RECIVED FILE DATA IS NULL"));
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI026";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }

        	// 파일 스트림은 한번만 생성
            if (RTN_CD.equals("00")) {
        		if (!createFile()) return false;
        	}
        	
            //받은 seq_no만큼만 데이터 확인하여 정상이면 파일에 기록하고, 비정상이면 받은 데이터 길이만 저장 
            for (int i=0; i < seq_no; i++) {
                byte[] data = (byte[]) block_data.get(new Integer(i));
                if (data != null ) {
                	if (RTN_CD.equals("00")) {
                		fout.write(data);
                	} else {
                		block_data_size += block_data.get(i).length;
                	}
                }
            }

            hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록 여부와 관계 없이  Vector 초기화

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI027";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }

    private boolean createFile () {
        try {
            String strFullPath = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (strFullPath.charAt(strFullPath.length()-1) != File.separatorChar) {
                strFullPath = strFullPath + this.getSeparator();
            }
            strFullPath = strFullPath + batchDoc.getBatchMsg().getHeader().getFileName();
            logger.info("{}  getCalculatedLength >> File full-path [" + strFullPath + "]", logHeader);
            file = new File(strFullPath);
            fout = new FileOutputStream(file, true);
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
    	String telegramNo = super.getFieldValueString(5);
    	if ( telegramNo.length() < 8 ) return "";
		return telegramNo.substring(0,3) + telegramNo.substring(6,7);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(9);
    }

}
